package etpdf;

import java.io.*;

import com.itextpdf.text.Anchor;

import com.itextpdf.text.Document;
import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.pdf.PdfStamper;
import com.itextpdf.text.pdf.PdfWriter;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.Font; 
import com.itextpdf.text.pdf.BaseFont;
import com.itextpdf.text.PageSize;
public class Etestpdf{
 
    String title="";
    String []qstr=new String[3001];
    String []astr=new String[3001];
    int num=0;

 
 
    
    public static void main(String[] args)throws DocumentException, IOException {
	
    	if(args.length==0){
	  System.out.println("Usage: Etestpdf.jar [folder path (in .sqa files)]");
	  return;
	}
	
	String path;
	
	path=args[0];//"C:/android/sdcard/srcdata/sjiskoubun";
	
	Etestpdf etest=new Etestpdf();
	etest.readdir(path);
	etest.createPdf(path+"/"+etest.title+"_n.pdf");
	etest.encryptPdf(path+"/"+etest.title+"_n.pdf",path+"/"+etest.title+".pdf");
	File file = new File(path+"/"+etest.title+"_n.pdf");
	file.delete();

    }
    
    public boolean IsSqa(String fileName)
    {
       
       int index = fileName.lastIndexOf('.');
       if (index!=-1)
       {
         String ext=fileName.substring(index + 1, fileName.length());

	 if(ext.equals("sqa")){
	   return true;
	 }
       }
       return false;
    }


    
    public void readdir(String dirpath){
            title=gettitle(dirpath);

	    File dir = new File(dirpath);
	    File[] files = dir.listFiles();
	    int i;
	    for (i = 0; i < files.length; i++) {
	        File file = files[i];
		String fileName = file.getName();
		
		if(IsSqa(fileName)==true){
		   String fpath= dirpath+"/"+fileName;
		//System.out.println(fpath);
		   read(fpath);
		}
	    }
	    
	    //for(i=0;i<num;i++){
	   // System.out.println(""+i+" q="+qstr[i]);
	   // System.out.println(""+i+" a="+astr[i]);
	   // }
	  

    }
    
    public String gettitle(String path){
       String title="";
       int i;
       i=path.lastIndexOf('/');
       if(i==-1){
         i=path.lastIndexOf('\\');
       }
       
       if(i>=0){
           title=path.substring(i+1);
	   
       }
       else{
          title=path;
       }
       return title;
    }
    
    
    public void read(String filepath){
        try{
	int qaflag=1;
	int sjisflag=1;
	FileInputStream fis = new FileInputStream(filepath); 
	byte b1=(byte)fis.read();
	byte b2=(byte)fis.read();
	byte b3=(byte)fis.read();
	if(b1==(byte)0xEF && b2==(byte)0xBB && b3==(byte)0xBF){
	    sjisflag=0;   //utf-8 bom
	}
	else{
	    fis.close();
	    fis = new FileInputStream(filepath);    //sjis or utf-8n
	}
	  
  
        InputStreamReader isr;
	if(sjisflag==0){
	  isr = new InputStreamReader(fis, "UTF-8");
	}
	else{
  	  isr = new InputStreamReader(fis, "SJIS");
	}   
  
        BufferedReader br = new BufferedReader(isr);   
  
        String line_buffer;
     
        int i=0;
        while ( null != (line_buffer = br.readLine() ) ) { 
	        line_buffer=line_buffer.trim();  

		
		if(i==0){
		  if(line_buffer.charAt(0)=='Q'){
		     qaflag=1;
		  }
		  else{
		     qaflag=0;
		  }
		  
		  if(line_buffer.length()>=3 && line_buffer.charAt(2)=='*'){
		             br.close();
			     isr.close();
			     fis.close();
			     return; 
	 
		  }
		  if(sjisflag==1 && line_buffer.length()>=3 && line_buffer.charAt(2)=='U'){
		     sjisflag=0;
		     br.close();
		     isr.close();
		     fis.close();
		     fis = new FileInputStream(filepath); 
	             isr = new InputStreamReader(fis, "UTF-8");  //utf-8n 
                     br = new BufferedReader(isr); 
		     line_buffer = br.readLine();
		  }
		  
		}
	
		i++;
		if(i==1 || i==2){
		  continue;
		}
		
		if(line_buffer.length()<=0){
		     continue;
		}  
	 
		if(qaflag==1){
		  qstr[num]=new String(line_buffer);
		  astr[num]=br.readLine().trim();
		}
		else{
		  astr[num]=new String(line_buffer);
		  qstr[num]=br.readLine().trim();
		}
		num++;
		if(num==3000){
		  break;
		}
		

		
        }   
  
  
        br.close();   
        isr.close();   
        fis.close();  
	 
        }   
        catch( Exception e  ) {   
            System.out.println(e.getMessage());   
        } 
	System.out.println(filepath+" ok.");
	return; 
    }
    public void encryptPdf(String src, String dest) throws IOException, DocumentException {
        PdfReader reader = new PdfReader(src);
        PdfStamper stamper = new PdfStamper(reader, new FileOutputStream(dest));
        stamper.setEncryption(null, null,PdfWriter.ALLOW_PRINTING, PdfWriter.STANDARD_ENCRYPTION_40  | PdfWriter.DO_NOT_ENCRYPT_METADATA);
        stamper.close();
    }


    public void createPdf(String filename) throws DocumentException, IOException {

        Document document = new Document(PageSize.B7.rotate(),16, 16, 16, 16);
//	document.setPageSize(PageSize.B7.rotate(),16, 16, 16, 16);
        PdfWriter writer=PdfWriter.getInstance(document, new FileOutputStream(filename));
	writer.setPdfVersion(PdfWriter.VERSION_1_3);
        //writer.setEncryption(PdfWriter.STANDARD_ENCRYPTION_128,"password1","password2",PdfWriter.ALLOW_COPY | PdfWriter.ALLOW_PRINTING); 
        


	document.addTitle(title);
	//document.addSubject("");
	//document.addKeywords("");
	//document.addCreator("");
	//document.addAuthor("");
	document.addHeader("Expires", "0");
        document.open();
	
	//targetParagraph.setSpacingBefore(50);
	
	Paragraph paragraph;
	Anchor anchor;
	//Font kaku_24 = new Font(BaseFont.createFont(//"KozGoPr6N-Medium", "UniJIS-UCS2-HW-H",true),18);
//	"HeiseiKakuGo-W5", "UniJIS-UCS2-H", BaseFont.EMBEDDED),18);
//HeiseiMin-W3", "UniJIS-UCS2-HW-H",true),18);
        
        BaseFont bf=null;
try{
bf=BaseFont.createFont("./sample.ttc,2",BaseFont.IDENTITY_H,BaseFont.EMBEDDED);
}
catch(IOException e00){
	try{
	bf=BaseFont.createFont("./sample.ttc,0",BaseFont.IDENTITY_H,BaseFont.EMBEDDED);
	}catch(IOException e02){
	try{
	  bf = BaseFont.createFont("c:\\windows\\fonts\\msgothic.ttc,2", BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
        }catch(IOException e){
	   bf = BaseFont.createFont("c:\\winnt\\fonts\\msgothic.ttc,2", BaseFont.IDENTITY_H, BaseFont.EMBEDDED);
	}
	}
}
	
	Font font = new Font(bf, 12);

	
	paragraph=new Paragraph("Content",font);
	document.add(paragraph);
        document.add(new Paragraph(" ",font));
	
	int i;
	for(i=0;i<=num;i++){
	  if(i%10==0){
	    paragraph=new Paragraph();
	    anchor =new Anchor("Section "+(i/10+1),font);
            anchor.setReference(String.format("#SEC%03d",i/10+1));
            paragraph.add(anchor);
            document.add(paragraph);
	  }
	}

	Paragraph p=null;
	for(i=0;i<=num;i++){
		document.newPage();


		if(i-1<0){
		  p=new Paragraph(" ",font);
		  document.add(p);
		}
		else{
		  p=new Paragraph(qstr[i-1],font);
		  document.add(p);
		}
		document.add(new Paragraph(" ",font));
	
		if(i-1<0){
		  p=new Paragraph(" ",font);
		  document.add(p);
		}
		else{
		  p=new Paragraph(astr[i-1],font);
		  document.add(p);
		}	
		document.add(new Paragraph(" ",font));
                
		
	        paragraph=new Paragraph();
	        anchor = new Anchor(String.format("( Section %d.  Number %d. )",i/10+1,i+1),font);
	        anchor.setName(String.format("SEC%03d",i/10+1));
	        paragraph.add(anchor);
		document.add(paragraph);

		if(i<num){
				
		  document.add(new Paragraph(qstr[i],font));
		}
	}	
	
        


        document.close();
	
	System.out.println(filename+" created.");
    }
}
